{
Gam_Bo_Prop ADS7846 Touchscreen Driver

written by GKR

based upon ADS7846 library from S.Watterott,www.watterott.com





}

CON
' Gam_Bo_Prop PIN MAP DEFINES

  ' SPI bus pins (modified C3 SPI-bus)
{
  PIN#s direct implemented in subroutine
  SPI_SEL0       = 0  ' used to select SPI channel
  SPI_SEL1       = 1  ' used to select SPI channel
  SPI_SEL2       = 2  ' used to select SPI channel
}

  SPI_MOSI       = 9  ' SPI master out serial in to slave
  SPI_MISO       = 10 ' SPI master in serial out from slave, 10 for good C3, change to 7 for BROKEN C3 with YELLOW jumper.
  SPI_SCK        = 11 ' SPI clock from master to all slaves

  ' SPI channels defines
  SPI_CHAN_NULL          = 0 ' NULL channel, disables all on/off board devices.
  SPI_CHAN_SRAM0         = 1 ' 32K SRAM Bank 0.
  SPI_CHAN_SRAM1         = 2 ' 32K SRAM Bank 1.
  SPI_CHAN_FLASH0        = 3 ' 2MB FLASH Memory.Bank 0
  SPI_CHAN_FLASH1        = 4 ' 2MB FLASH Memory Bank 1
  SPI_CHAN_SD            = 5 ' SD Card./ SD-ModulChannel 0
  SPI_CHAN_SDM1          = 6 ' SD-Modul Channel 1.
  SPI_CHAN_SDM2          = 7 ' SD-Modul Channel 2.

  ' Detection of SD-Card or SD-Modul
  WP            = 6 ' Detect WP used with CDET to determine, if a SD-Card or SD-Modul is inserted
  CD            = 7 ' Detect CD (Card detect)

  ' Audio stereo output pin define (PWM)
  A_RIGHT       = 4
  A_LEFT        = 5
{
  PIN#s direct implemented in subroutine
  KEY_A         = 12
  KEY_B         = 13
  KEY_C         = 14
  KEY_D         = 15
}

  ' LCD-Display (SPI-bus only for MIO283QT2)
  LCD_LED       = 8
  LCD_DO        = 18
  LCD_SCK       = 19
  LCD_DI        = 20
  LCD_CS        = 21
  LCD_RES       = 22

  ' Touchscreen controller (SPI-bus only for ADS7846)
  TO_DO         = 23
  TO_SCK        = 24
  TO_DI         = 25
  TO_CS         = 26

  ' I2C pin defines (standard Prop pins)
  SCL           = 28
  SDA           = 29

  ' TX/RX pin defines (standard Prop pins)
  RXD           = 30
  TXD           = 31

{
  'Unused and unconnected Pins
  P3            = 3
  P16           = 16
  P17           = 17
  P27           = 27
}

CON
'ADS7846 System Defines

  CLOCKS_PER_MICROSECOND = 10*8     ' simple xin*pll / 1_000_000
  CLOCKS_PER_MILLISECOND = 10000*8  ' simple xin*pll / 1_000
  LCD_WIDTH = 320
  LCD_HEIGHT = 240
OBJ
  rtc   : "DS1307_RTCEngine.spin"    ' RTC and 56B Ram driver
  lcd   : "GBP_MIO283QT2.spin"       ' LCD driver

VAR

  long cog , cogon
  long touchstack[40]
  long mat[7]

PUB start : ok
'  stop
'  ok := cogon := (cog := cognew(ADS7846, @touchstack)) > 0
  cog:=cognew(ADS7846, @touchstack)
  return cog

PUB stop
' Stop keyboard driver - frees a cog

  if cogon~
    cogstop(cog)

PUB ADS7846

  'Initialise the SPI-Interface to ADS7846 chip
  SPI_Init
   ' initialize the RTC with 56B Ram
  rtc.RTCEngineStart(SDA, SCL, -1)


PUB SPI_Init
{{
This function initializes the SPI IO's, counter, and mux, selects channel 0 and returns.

PARMS: none.
RETURNS: nothing.
}}
  ' set TO_CS direction to output and high
  DIRA[TO_CS]       := 1      ' set to output
  OUTA[TO_CS]       := 1      ' set to high

  ' set up SPI lines
  DIRA[TO_DI]       := 1      ' set to output
  DIRA[TO_DO]       := 0      ' set to input
  DIRA[TO_SCK]      := 1      ' set to output

  OUTA[TO_DI]       := 0      ' set to low
  OUTA[TO_SCK]      := 0      ' set to low

  OUTA[TO_CS]       := 0      ' set to low

' end SPI_Init


PUB getXraw | x

  return x

PUB getYraw | y

  return y

PUB getVoltage | v
  v := 0
' TO_CS low = select ADS7846
  OUTA[TO_CS] := 0
  SPI_Write( 8, %10101101)
  v := SPI_Read( 8, $00)
' TO_CS high = deselect ADS7846
  OUTA[TO_CS] := 1
  return v

PUB getTemp0 | t
  t := 0
' TO_CS low = select ADS7846
  OUTA[TO_CS] := 0
  SPI_Write( 8, %10001101)
  t := SPI_Read( 8, $00)
' TO_CS high = deselect ADS7846
  OUTA[TO_CS] := 1
  return t

PUB getTemp1 | t
  t := 0
' TO_CS low = select ADS7846
  OUTA[TO_CS] := 0
  SPI_Write( 8, %11111101)
  t := SPI_Read( 8, $00)
' TO_CS high = deselect ADS7846
  OUTA[TO_CS] := 1
  return t

PUB getX | x
  x := 0
  if getPressure > 5
    x := 0
'   TO_CS low = select ADS7846
    OUTA[TO_CS] := 0
    SPI_Write( 8, %11011001)
    x := SPI_Read( 12, $00)
  ' TO_CS high = deselect ADS7846
    OUTA[TO_CS] := 1
  return x

PUB getY | y
  y := 0
  if getPressure > 5
  ' TO_CS low = select ADS7846
    OUTA[TO_CS] := 0
    SPI_Write( 8, %10011001)
    y := SPI_Read( 12, $00)
  ' TO_CS high = deselect ADS7846
    OUTA[TO_CS] := 1
  return y

PUB getPressure | p, p1, p2
  p := 0
  p1 := 0
  p2 := 0

' TO_CS low = select ADS7846
  OUTA[TO_CS] := 0
  SPI_Write( 8, %10111101)
  p1 := SPI_Read( 8, $00)
  SPI_Write( 8, %11001101)
  p2 := 127 - SPI_Read( 8, $00)
' TO_CS high = deselect ADS7846
  OUTA[TO_CS] := 1
  p := p1+p2
  return p

PUB setCalibration(lcdx1,lcdy1,lcdx2,lcdy2,lcdx3,lcdy3,x1,y1,x2,y2,x3,y3) | i,addr
  'Set calibration and store it in RTC-Ram
  mat[0] := ((x1-x3)*(y2-y3))-((x2-x3)*(y1-y3))

  if(mat[0] == 0)

    return 0
  else

    mat[1] := ((lcdx1-lcdx3)*(y2-y3))-((lcdx2-lcdx3)*(y1-y3))
    mat[2] := ((x1-x3)*(lcdx2-lcdx3))-((lcdx1-lcdx3)*(x2-x3))
    mat[3] := (x3*lcdx2-x2*lcdx3)*y1+(x1*lcdx3-x3*lcdx1)*y2+(x2*lcdx1-x1*lcdx2)*y3
    mat[4] := ((lcdy1-lcdy3)*(y2-y3))-((lcdy2-lcdy3)*(y1-y3))
    mat[5] := ((x1-x3)*(lcdy2-lcdy3))-((lcdy1-lcdy3)*(x2-x3))
    mat[6] := (x3*lcdy2-x2*lcdy3)*y1+(x1*lcdy3-x3*lcdy1)*y2+(x2*lcdy1-x1*lcdy2)*y3
    lcd.setX(1)
    lcd.setY(3)
    repeat i from 0 to 6 step 1
      lcd.hex(mat[i],4)
      lcd.crlf
    saveCal

    return 1

PUB saveCal | i, j, addr, value
  'Save calibration data to RTC-Ram address : $10 to $2B
  'Startaddress in SRAM = $10
  addr := $10
  repeat j from 0 to 6 step 1
    repeat i from 0 to 3 step 1
      value := mat[J]
      rtc.writeSRAM(addr, value.byte[i])
      addr += 1
  lcd.setX(3)
  lcd.setY(3)
  repeat i from 0 to 6 step 1
    lcd.hex(mat[i],4)
    lcd.crlf
    lcd.setX(3)

PUB printCal | i, j, value, addr
  'Print calibration data from RTC-Ram to screen (in testprogram)
  readCal
  lcd.setX(3)
  lcd.setY(3)
  repeat i from 0 to 6 step 1
    lcd.hex(mat[i],4)
    lcd.crlf
    lcd.setX(3)

PUB readCal | i, j, value, addr
  'Read calibration data from RTC-Ram address : $10 to $2B
  addr := $10
  repeat j from 0 to 6 step 1
    repeat i from 0 to 3
      value.byte[i] := rtc.readSRAM(addr)
      mat[j] := value
      addr +=  1

PUB calX(tpx,tpy) | x
'
  x := ((mat[1] * tpx) + (mat[2] * tpy) + mat[3]) / mat[0]
  if(x < 0)
    x := 0
  elseif x => LCD_WIDTH
    x := LCD_WIDTH-1

  return x

PUB calY(tpx,tpy) | y
' calc y pos
  y := ((mat[4] * tpx) + (mat[5] * tpy) + mat[6]) / mat[0]
  if(y < 0)
    y := 0
  elseif y => LCD_HEIGHT
    y := LCD_HEIGHT-1

  return y

PUB SPI_Write_Read( num_bits, data_out, bit_mask) | data_in

'This function writes and reads SPI data a bit at a time (SPI is a circular
'buffer protocal), the data is in MSB to LSB format
'and up to 32-bits can be transmitted and received, the final result is
'bit masked by bit_mask

'PARMS:

'num_bits : number of bits to transmit from data_out
'data_out : source of data to transmit
'bit_mask : final result of SPI transmission is masked with this to grab the relevant least significant bits

'RETURNS: data retrieved from SPI transmission

  ' clear result
  data_in := 0

  ' now read the bits in/out
  repeat num_bits
    ' drop clock
    OUTA[TO_SCK] := 0
'    repeat 8

    ' place next bit on TO_DI
    OUTA[TO_DI]  := ((data_out >> (num_bits-- - 1)) & $01)

    ' now read next bit from TD_DO
    data_in := (data_in << 1) + INA[TO_DO]

    ' raise clock
    OUTA[TO_SCK] := 1

  ' set clock and MOSI to LOW on exit
  OUTA[TO_DI]    := 0
  OUTA[TO_SCK]   := 0

  ' at this point, the data has been written and read, return result
  return ( data_in & bit_mask )

' end SPI_Write_Read

PUB SPI_Write( num_bits, data_out)

'This function writes and reads SPI data a bit at a time (SPI is a circular
'buffer protocal), the data is in MSB to LSB format
'and up to 32-bits can be transmitted and received, the final result is
'bit masked by bit_mask

'PARMS:

'num_bits : number of bits to transmit from data_out
'data_out : source of data to transmit
'bit_mask : final result of SPI transmission is masked with this to grab the relevant least significant bits

'RETURNS: data retrieved from SPI transmission
  ' now read the bits in/out
  repeat num_bits
    ' drop clock
    OUTA[TO_SCK] := 0
'    repeat 8

    ' place next bit on TO_DI
    OUTA[TO_DI]  := ((data_out >> (num_bits-- - 1)) & $01)
    ' raise clock
    OUTA[TO_SCK] := 1

  ' set clock and MOSI to LOW on exit
  OUTA[TO_DI]    := 0
  OUTA[TO_SCK]   := 0

  ' at this point, the data has been written and read, return result

PUB SPI_Read( num_bits, bit_mask) | data_in

'This function writes and reads SPI data a bit at a time (SPI is a circular
'buffer protocal), the data is in MSB to LSB format
'and up to 32-bits can be transmitted and received, the final result is
'bit masked by bit_mask

'PARMS:

'num_bits : number of bits to transmit from data_out
'data_out : source of data to transmit
'bit_mask : final result of SPI transmission is masked with this to grab the relevant least significant bits

'RETURNS: data retrieved from SPI transmission

  ' clear result
  data_in := 0

  ' now read the bits in/out
  repeat num_bits
    ' drop clock
    OUTA[TO_SCK] := 0
    ' now read next bit from TD_DO
    data_in := (data_in << 1) + INA[TO_DO]
    ' raise clock
    OUTA[TO_SCK] := 1

  ' set clock and MOSI to LOW on exit
  OUTA[TO_DI]    := 0
  OUTA[TO_SCK]   := 0

  ' at this point, the data has been written and read, return result
  return ( data_in ) '& bit_mask )

PUB Delay_MS( time )
'Delays "time" milliseconds and returns.
  waitcnt (cnt + time*CLOCKS_PER_MILLISECOND)

PUB Delay_US( time )
'Delays "time" microseconds and returns.
  waitcnt (cnt + time*CLOCKS_PER_MICROSECOND)


{
'Export some RTC-Functions
PUB ReadSRAM(address) | value
'Export function to save program space
'Read byte from RTC-SRAM at address.
  value := rtc.readSRAM(address)

PUB WriteSRAM(address,value)
'Export function to save program space
'Write byte to RTC-SRAM at address
  rtc.writeSRAM(address, value)
}





DAT

{{ LICENSE SECTION

                          TERMS OF USE: MIT License                                                  |

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation  the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:                                                                   |
                                                                                                                              |
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
}}



