{
GBP_BGLED_T2

Testprogram 2 for Gam_Bo_Prop

Testing the background-LED-driver

'Gam_Bo_Prop' is the short name of 'game board propeller'
'Gambo' is also the name given to an unidentified large marine animal

(C) 2011 GKR

}

CON

  _clkmode = xtal1 + pll8x      ' enable external clock and pll times 8
  _xinfreq = 10_000_000         ' set frequency to 10 MHZ plus some error

' Gam_Bo_Prop PIN MAP DEFINES

  ' SPI pins
{
  PIN#s direct implemented in subroutine
  SPI_SEL0       = 0  ' used to select SPI channel
  SPI_SEL1       = 1  ' used to select SPI channel
  SPI_SEL2       = 2  ' used to select SPI channel
}

  SPI_MOSI       = 9  ' SPI master out serial in to slave
  SPI_MISO       = 10 ' SPI master in serial out from slave, 10 for good C3, change to 7 for BROKEN C3 with YELLOW jumper.
  SPI_SCK        = 11 ' SPI clock from master to all slaves

  ' SPI channels defines
  SPI_CHAN_NULL          = 0 ' NULL channel, disables all on/off board devices.
  SPI_CHAN_SRAM0         = 1 ' 32K SRAM Bank 0.
  SPI_CHAN_SRAM1         = 2 ' 32K SRAM Bank 1.
  SPI_CHAN_FLASH0        = 3 ' 2MB FLASH Memory.Bank 0
  SPI_CHAN_FLASH1        = 4 ' 2MB FLASH Memory Bank 1
  SPI_CHAN_SD            = 5 ' SD Card./ SD-ModulChannel 0
  SPI_CHAN_SDM1          = 6 ' SD-Modul Channel 1.
  SPI_CHAN_SDM2          = 7 ' SD-Modul Channel 2.

  ' Detection of SD-Card or SD-Modul
  WP            = 6 ' Detect WP used with CDET to determine, if a SD-Card or SD-Modul is inserted
  CD            = 7 ' Detect CD (Card detect)



  ' Audio stereo output pin define (PWM)
  A_RIGHT       = 4
  A_LEFT        = 5


{
  ' Keyboard

  PIN#s direct implemented in subroutine
  KEY_A         = 12
  KEY_B         = 13
  KEY_C         = 14
  KEY_D         = 15
}

  ' LCD-Display
  LCD_LED       = 8
  LCD_DO        = 18
  LCD_SCK       = 19
  LCD_DI        = 20
  LCD_CS        = 21
  LCD_RES       = 22

  ' Touchscreen controller
  TO_DO         = 23
  TO_SCK        = 24
  TO_DI         = 25
  TO_CS         = 26

  ' I2C pin defines (standard Prop pins)
  SCL           = 28
  SDA           = 29

  ' TX/RX pin defines (standard Prop pins)
  RXD           = 30
  TXD           = 31



{
  'Unused and unconnected Pins
  P3            = 3
  P16           = 16
  P17           = 17
  P27           = 27
}

  ' null pointer, null character
  NULL         = 0

  LCD_WIDTH  = 320
  LCD_HEIGHT = 240


  ' LCD-Color
  tbcolor        = $0000FF
  tfcolor        = $FFFF00
  mbcolor        = $FFFF00
  mfcolor        = $0000FF
  wbcolor        = $FF0000
  wfcolor        = $FFFFFF


OBJ

  led  : "GBP_BGLED.spin"        ' Background LED-Treiber

PUB Main |  index
'Start LED-backlight
repeat
  repeat index from 1 to 99 step 1
    led.start(index) 'LCD backlight 1% - 99%
    led.delay_us(100_000)
  repeat index from 99 to 1 step 1
    led.start(index) 'LCD backlight 99% - 1%
    led.delay_us(100_000)

DAT

{

                          TERMS OF USE: MIT License                                                  |

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation  the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:                                                                   |
                                                                                                                              |
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
}
