{
GBP_GKEY_T4

Testprogram 4 for Gam_Bo_Prop

game-keyboard test

'Gam_Bo_Prop' is the short name of 'game board propeller'
'Gambo' is also the name given to an unidentified large marine animal

(C) 2011 GKR

LICENSE: MIT

}
CON

  _clkmode = xtal1+pll8x
  _xinfreq = 10_000_000

  LCD_WIDTH = 320
  LCD_HEIGHT = 240
' Gam_Bo_Prop PIN MAP DEFINES

  ' SPI bus pins (modified C3 SPI-bus)
{
  PIN#s direct implemented in subroutine
  SPI_SEL0       = 0  ' used to select SPI channel
  SPI_SEL1       = 1  ' used to select SPI channel
  SPI_SEL2       = 2  ' used to select SPI channel
}

  SPI_MOSI       = 9  ' SPI master out serial in to slave
  SPI_MISO       = 10 ' SPI master in serial out from slave, 10 for good C3, change to 7 for BROKEN C3 with YELLOW jumper.
  SPI_SCK        = 11 ' SPI clock from master to all slaves

  ' SPI channels defines
  SPI_CHAN_NULL          = 0 ' NULL channel, disables all on/off board devices.
  SPI_CHAN_SRAM0         = 1 ' 32K SRAM Bank 0.
  SPI_CHAN_SRAM1         = 2 ' 32K SRAM Bank 1.
  SPI_CHAN_FLASH0        = 3 ' 2MB FLASH Memory.Bank 0
  SPI_CHAN_FLASH1        = 4 ' 2MB FLASH Memory Bank 1
  SPI_CHAN_SD            = 5 ' SD Card./ SD-ModulChannel 0
  SPI_CHAN_SDM1          = 6 ' SD-Modul Channel 1.
  SPI_CHAN_SDM2          = 7 ' SD-Modul Channel 2.

  ' Detection of SD-Card or SD-Modul
  WP            = 6 ' Detect WP used with CDET to determine, if a SD-Card or SD-Modul is inserted
  CDET          = 7 ' Detect CD (Card detect)



  ' Audio stereo output pin define (PWM)
  A_RIGHT       = 4
  A_LEFT        = 5
{
  PIN#s direct implemented in subroutine
  KEY_A         = 12
  KEY_B         = 13
  KEY_C         = 14
  KEY_D         = 15
}

  ' LCD-Display (SPI-bus only for MIO283QT2)
  LCD_LED       = 8
  LCD_DO        = 18
  LCD_SCK       = 19
  LCD_DI        = 20
  LCD_CS        = 21
  LCD_RES       = 22

  ' Touchscreen controller (SPI-bus only for ADS7846)
  TO_DO         = 23
  TO_SCK        = 24
  TO_DI         = 25
  TO_CS         = 26

  ' I2C pin defines (standard Prop pins)
  SCL           = 28
  SDA           = 29

  ' TX/RX pin defines (standard Prop pins)
  RXD           = 30
  TXD           = 31

{
  'Unused and unconnected Pins
  P3            = 3
  P16           = 16
  P17           = 17
  P27           = 27
}
  ' null pointer, null character
  NULL         = 0

VAR

  long keystack[12]
  long Temp
  long fcolor
  long bcolor
  long tcolor

OBJ
  led   : "GBP_BGLED.spin"           ' LED-driver
  lcd   : "GBP_MIO283QT2.spin"       ' lcd-driver
  key   : "GBP_gkey.spin"            ' game-keyboard driver

PUB Main

  ' Start the Background LED-driver
  led.start(10) 'LCD backlight 10%

  lcd.start(LCD_CS, LCD_SCK, LCD_DI, LCD_RES)

  key.start
  lcd.clear
'initialise LCD, print background color (black) and draw buttons
  fcolor := $FF0000
  bcolor := $0000FF
  tcolor := $FFFF00
  'if lcd.start <> -1
    lcd.fillcircle(50, 120, 6, tcolor)     'E
    lcd.fillcircle(100, 170, 6, tcolor)    'D
    lcd.fillcircle(150, 120, 6, tcolor)    'C
    lcd.fillcircle(100, 70, 6, tcolor)     'B
    lcd.fillcircle(300, 45, 6, tcolor)     'A
    lcd.fillcircle(300, 95, 6, tcolor)     '9
    lcd.fillcircle(300, 145, 6, tcolor)    '8
    lcd.fillcircle(300, 195, 6, tcolor)    '7
    lcd.Text( 3, 1, string ("Gam_Bo_Prop onboard game-keyboard test"+0))
    lcd.Text( 3, 2, string ("Test program 5"))
    lcd.Text( 3, 3, string ("Push any key........"))
    lcd.Text( 3, 19,string ("Pushed key : "+0))

'Query the button state
    repeat
      case key.key
        1 : pressed (1, 50, 120)   '1
        2 : pressed (2, 100, 170)  '2
        3 : pressed (3, 150, 120)  '3
        4 : pressed (4, 100, 70)   '4
        5 : pressed (5, 300, 45)   '5
        6 : pressed (6, 300, 95)   '6
        7 : pressed (7, 300, 145)  '7
        8 : pressed (8, 300, 195)  '8
        0 : pressed (0, 0, 0)

PRI pressed (code, x, y)| char

  itoa(code,char)
  lcd.fillcircle(x, y, 6, fcolor) 'draw pushed button in red
  lcd.Text(17 , 19,char)
  repeat while key.key == code
    waitcnt(80000 + cnt)
  lcd.fillcircle(x, y, 6, tcolor) 'draw released button in green
  lcd.Text(17 , 19,char)

PUB itoa(value, string_ptr) | i
{{
 converts value into a string and stores in string_ptr with NULL termination
 }}

  if value < 0
    -value
    byte [ string_ptr++ ]  := "-"

  i := 1_000_000_000

  repeat 10
    if value => i
      byte [ string_ptr++ ]  := value / i + "0"
      value //= i
      result~~
    elseif result or i == 1
      byte [ string_ptr++ ]  := "0"
    i /= 10

  ' null terminate
  byte [ string_ptr ] := NULL

DAT


{{ LICENSE SECTION

                          TERMS OF USE: MIT License                                                  |

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation  the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:                                                                   |
                                                                                                                              |
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
}}
