{
GBP_TOUCH_T8

Testprogram 8 for Gam_Bo_Prop

Testing the touchscreen

'Gam_Bo_Prop' is the short name of 'game board propeller'
'Gambo' is also the name given to an unidentified large marine animal

(C) 2011 GKR

LICENSE: MIT
 
}

CON

' PROP CHIP / SYSTEM DEFINES
  ' These settings are for 10 MHZ XTALS
  _clkmode = xtal1 + pll8x          ' enable external clock and pll times 8
  _xinfreq = 10_000_000             ' set frequency to 10 MHZ

  CLOCKS_PER_MICROSECOND = 10*8     ' simple xin*pll / 1_000_000
  CLOCKS_PER_MILLISECOND = 10000*8  ' simple xin*pll / 1_000

  _stack   = 125                    ' accomodate display memory and stack

' Gam_Bo_Prop PIN MAP DEFINES

  ' SPI bus pins (modified C3 SPI-bus)
{
  PIN#s direct implemented in subroutine
  SPI_SEL0       = 0  ' used to select SPI channel
  SPI_SEL1       = 1  ' used to select SPI channel
  SPI_SEL2       = 2  ' used to select SPI channel
}

  SPI_MOSI       = 9  ' SPI master out serial in to slave
  SPI_MISO       = 10 ' SPI master in serial out from slave, 10 for good C3, change to 7 for BROKEN C3 with YELLOW jumper.
  SPI_SCK        = 11 ' SPI clock from master to all slaves

  ' SPI channels defines
  SPI_CHAN_NULL          = 0 ' NULL channel, disables all on/off board devices.
  SPI_CHAN_SRAM0         = 1 ' 32K SRAM Bank 0.
  SPI_CHAN_SRAM1         = 2 ' 32K SRAM Bank 1.
  SPI_CHAN_FLASH0        = 3 ' 2MB FLASH Memory.Bank 0
  SPI_CHAN_FLASH1        = 4 ' 2MB FLASH Memory Bank 1
  SPI_CHAN_SD            = 5 ' SD Card./ SD-ModulChannel 0
  SPI_CHAN_SDM1          = 6 ' SD-Modul Channel 1.
  SPI_CHAN_SDM2          = 7 ' SD-Modul Channel 2.

  ' Detection of SD-Card or SD-Modul
  WP            = 6 ' Detect WP used with CDET to determine, if a SD-Card or SD-Modul is inserted
  CDET          = 7 ' Detect CD (Card detect)



  ' Audio stereo output pin define (PWM)
  A_RIGHT       = 4
  A_LEFT        = 5
{
  PIN#s direct implemented in subroutine
  KEY_A         = 12
  KEY_B         = 13
  KEY_C         = 14
  KEY_D         = 15
}

  ' LCD-Display (SPI-bus only for MIO283QT2)
  LCD_LED       = 8
  LCD_DO        = 18
  LCD_SCK       = 19
  LCD_DI        = 20
  LCD_CS        = 21
  LCD_RES       = 22

  ' Touchscreen controller (SPI-bus only for ADS7846)
  TO_DO         = 23
  TO_SCK        = 24
  TO_DI         = 25
  TO_CS         = 26

  ' I2C pin defines (standard Prop pins)
  SCL           = 28
  SDA           = 29

  ' TX/RX pin defines (standard Prop pins)
  RXD           = 30
  TXD           = 31

{
  'Unused and unconnected Pins
  P3            = 3
  P16           = 16
  P17           = 17
  P27           = 27
}

VAR

  long mat[7]

OBJ

  ' current drivers used in this version of SPI interface
  key   : "GBP_gkey.spin"            ' game-keyboard driver
  lcd   : "GBP_MIO283QT2.spin"       ' LCD driver
  tp    : "GBP_ADS7846.spin"         ' Touchscreen driver
  led   : "GBP_BGLED.spin"           ' LED-driver

PUB Main : status

  ' let the system initialize 
  ' initialize the LCD-Display
  lcd.start(LCD_CS, LCD_SCK, LCD_DI, LCD_RES)

  ' initialize the Keyboard
  key.start

  ' initialize touchpannel
  tp.ADS7846 'SPI_init

  ' Start the Background LED-driver
  led.start(30) 'LCD backlight 10%

  ' begin test loop
  repeat
    ' clear screen
    lcd.clear

    ' call the test
    Touch_Demo


PUB Touch_Demo | x,y,m,keycode,p,v,t0,x1,x2,x3,y1,y2,y3,lcdx1,lcdx2,lcdx3,lcdy1,lcdy2,lcdy3,hour,minute,day,year,month,date,i

  ' draw menu
  lcd.Text( 3, 1, string ("Gam_Bo_Prop Touchscreen Test"))
  lcd.Text( 3, 3, string ("Key 1 = Calibration, saved to RTC-Ram"))
  lcd.Text( 3, 4, string ("Key 2 = Read calibration from RTC-Ram"))
  lcd.Text( 3, 5, string ("Key 3 = show pressure"))
  lcd.Text( 3, 6, string ("Key 4 = show temperature"))
  lcd.Text( 3, 7, string ("Key 5 = show voltage"))
  lcd.Text( 3, 8, string ("Key 6 = show x,y"))
  lcd.Text( 3, 9, string ("Key 7 = Draw pixel with pen"))
  lcd.Text( 3, 10, string ("Key 8 = Repeat main menu"))

  ' wait for keypress (button 1 to 8)
  keycode := key.waitforkey
  case keycode
    1 : 'Set the calibration of the touch panel
        lcd.clear
        x1 := 0
        x2 := 0
        x3 := 0
        y1 := 0
        y2 := 0
        y3 := 0
        lcd.Text( 3, 1, string ("Gam_Bo_Prop touchscreen calibration"))
        lcd.Text( 3,20, string ("Key 8 = To main menu"))
        lcd.Text( 3,19, string ("Hit point 1, then 2 and then 3"))
        lcdx1 := 20
        lcdx2 := 220
        lcdx3 := 280
        lcdy1 := 20
        lcdy2 := 80
        lcdy3 := 200
        lcd.drawcircle(lcdx1,lcdy1, 2, $FFFF00)
        lcd.Text( 5, 2, string ("<--Point 1"))
        repeat while x1 == 0
          x1 := tp.getX
        repeat while y1 == 0
          y1 := tp.getY
        repeat while tp.getPressure > 5
        lcd.Text( 5, 2, string ("<--OK     "))
        lcd.Text(17, 7, string ("Point 2-->"))
        lcd.drawcircle(lcdx2,lcdy2, 2, $FFFF00)
        repeat while x2 == 0
          x2 := tp.getX
        repeat while y2 == 0
          y2 := tp.getY
        repeat while tp.getPressure > 5
        lcd.Text(17, 7, string ("     OK-->"))
        lcd.Text(25,17, string ("Point 3-->"))
        lcd.drawcircle(lcdx3,lcdy3, 2, $FFFF00)
        repeat while x3 == 0
          x3 := tp.getX
        repeat while y3 == 0
          y3 := tp.getY
        repeat while tp.getPressure > 5
        lcd.Text(25,17, string ("     OK-->"))
        lcd.Text( 3,19, string ("The calibration is done       "))
        mat := tp.setCalibration(lcdx1,lcdy1,lcdx2,lcdy2,lcdx3,lcdy3,x1,y1,x2,y2,x3,y3)
        repeat until key.key == 8

    2 : 'Read calibration
        lcd.clear
        lcd.Text( 3, 1, string ("Gam_Bo_Prop read calibration"))
        lcd.Text( 3,20, string ("Key 8 = To main menu"))
        tp.printCal
        repeat until key.key == 8

    3 : 'Show pressure
        lcd.clear
        lcd.Text( 3, 1, string ("Gam_Bo_Prop Touchscreen Test"))
        lcd.Text( 3, 2, string ("Key 8 = To main menu"))
        lcd.Text( 3, 3, string ("Show pressure :"))
        repeat until key.key == 8
          p := tp.getPressure
          lcd.setx(3)
          lcd.sety(4)
          lcd.hex(p,2)

    4 : lcd.clear
        lcd.Text( 3, 1, string ("Gam_Bo_Prop Touchscreen Test"))
        lcd.Text( 3, 2, string ("Key 8 = To main menu"))
        lcd.Text( 3, 3, string ("Show temperature :"))
        repeat until key.key == 8
          t0 := tp.getTemp0
          lcd.setx(3)
          lcd.sety(4)
          lcd.hex(t0,4)
          lcd.setx(3)
          lcd.sety(5)
          lcd.dec(t0)
          delay_MS(1000)

    5 : lcd.clear
        lcd.Text( 3, 1, string ("Gam_Bo_Prop Touchscreen Test"))
        lcd.Text( 3, 2, string ("Key 8 = To main menu"))
        lcd.Text( 3, 3, string ("Show voltage :"))
        repeat until key.key == 8
          v := tp.getVoltage
          lcd.setx(3)
          lcd.sety(4)
          lcd.hex(v,4)
          delay_MS(1000)

    6 : lcd.clear
        lcd.Text( 3, 1, string ("Gam_Bo_Prop Touchscreen Test"))
        lcd.Text( 3, 2, string ("Key 8 = To main menu"))
        lcd.Text( 3, 3, string ("Show x ,  y :"))
        repeat until key.key == 8
          x := tp.getX
          y := tp.getY
          lcd.setx(8)
          lcd.sety(4)
          lcd.hex(x,4)
          lcd.setx(13)
          lcd.sety(4)
          lcd.hex(y,4)

    7 : lcd.clear
        lcd.Text( 3, 1, string ("Gam_Bo_Prop Touchscreen Test"))
        lcd.Text( 3, 2, string ("Key 8 = To main menu"))
        lcd.Text( 3, 3, string ("draw  x ,y :"))
        repeat until key.key == 8
          x := tp.calX(tp.getX,tp.getY)
          y := tp.calY(tp.getX,tp.getY)
          lcd.drawapixel(x, y, $FFFF00)

    8 :




PUB Delay_MS( time )
'Delays "time" milliseconds and returns.
  waitcnt (cnt + time*CLOCKS_PER_MILLISECOND)

PUB Delay_US( time )
'Delays "time" microseconds and returns.
  waitcnt (cnt + time*CLOCKS_PER_MICROSECOND)


DAT

{{ LICENSE SECTION

                          TERMS OF USE: MIT License                                                  |

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation  the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:                                                                   |
                                                                                                                              |
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
}}
