{
 Gam_Bo_Prop Keyboard Driver

 (C) 2011 GKR

 The GBP contains eight Buttons four on each side of the LCD-display

 Key #'s

          ----------------  5
    4     |              |
          |              |  6
 1     3  | LCD-display  |
          |              |  7
    2     |              |
          ----------------  8

 Port-Pins 15 to 12 (Propeller Input) are the interface to the Keyboard-Controller 74HC147 Output-Pins A to D
 Propeller Port        74HC147 Port
   15    = Bit 4  MSB  D
   14    = Bit 3       C
   13    = Bit 2       B
   12    = Bit 1  LSB  A


LICENSE : MIT
}
VAR

  long cog , cogon
  long keystack[20]


PUB start : ok
'  stop
'  ok := cogon := (cog := cognew(key, @keystack)) > 0
  cog := cognew(keyloop, @keystack)
  dira[15..12]~
  return cog

PUB stop
' Stop keyboard driver - frees a cog

  if cogon~
    cogstop(cog)

PUB keyloop
  repeat

PUB key : keycode
'
' Query Port lines 15 to 12 and returns the key number
  case ina[15..12]
    $E     : keycode := 1
    $D     : keycode := 2
    $C     : keycode := 3
    $B     : keycode := 4
    $A     : keycode := 5
    $9     : keycode := 6
    $8     : keycode := 7
    $7     : keycode := 8
    OTHER  : keycode := 0

PUB waitforkey : keycode
'Waiting for pushing a key. When a key ist pushed the funktion
'returns the keycode 1 to 8
'
  repeat while keycode == 0
    keycode := key
    waitcnt(800_000 + cnt)

DAT

{{ LICENSE SECTION

                          TERMS OF USE: MIT License                                                  |

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation  the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:                                                                   |
                                                                                                                              |
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
}}


